
	FUNCTION MELP2(K,F)
	DOUBLE PRECISION MELP2,K,F,Y,PI,E,FF,FFF,EK1
	IF ((K.LT.0.0).OR.(K.GT.1.0)) THEN
	  MELP2=-1.0E+37
	  RETURN
	END IF
	PI=3.1415926
	Y=ABS(F)
	N=0
10	IF (Y.GE.PI) THEN
	  N=N+1
	  Y=Y-PI
	  GOTO 10
	END IF
	E=1.0
	IF (Y.GE.PI/2) THEN
	  N=N+1
	  E=-1.0
	  Y=PI-Y
	END IF
	IF (N.EQ.0) THEN
	  FF=EK1(K,Y)
	  MELP2=FF
	  RETURN
	ELSE
	  FF=EK1(K,PI/2.0)
	  FFF=EK1(K,Y)
	  MELP2=2.0*N*FF+E*FFF
	  RETURN
	END IF
	END

	FUNCTION EK1(K,Y)
	DIMENSION T(5),C(5)
	DOUBLE PRECISION EK1,K,Y,A,B,F,G,T,C,S,P,H,AA,BB,W,X,Q
	DATA T/-0.9061798459,-0.5384693101,0.0,
     *          0.5384693101,0.9061798459/
	DATA C/0.2369268851,0.4786286705,0.5688888889,
     *         0.4786286705,0.2369268851/
	A=0.0
	B=Y
	M=1
	S=(B-A)*0.02
	P=0.0
10	H=(B-A)/M
	G=0.0
	DO 30 I=1,M
	  AA=A+(I-1)*H
	  BB=A+I*H
	  W=0.0
	  DO 20 J=1,5
	    X=((BB-AA)*T(J)+(BB+AA))/2.0
	    EK1=SQRT(1.0-K*K*SIN(X)*SIN(X))
	    W=W+EK1*C(J)
20	  CONTINUE
	  G=G+W
30	CONTINUE
	G=G*H/2.0
	Q=ABS(G-P)/(1.0+ABS(G))
	IF ((Q.GE.1.0D-10).AND.(ABS(H).GT.ABS(S))) THEN
	  P=G
	  M=M+1
	  GOTO 10
	END IF
	EK1=G
	RETURN
	END

